'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

require('core-js/modules/es.object.to-string');
require('core-js/modules/es.array.for-each');
require('core-js/modules/es.array.slice');
require('core-js/modules/es.object.get-own-property-descriptor');
require('core-js/modules/es.object.get-own-property-names');
require('core-js/modules/es.object.get-prototype-of');
require('core-js/modules/es.object.set-prototype-of');
require('core-js/modules/web.dom-collections.for-each');
var _typeof = _interopDefault(require('@babel/runtime/helpers/typeof'));
require('core-js/modules/es.array.filter');
require('core-js/modules/es.array.index-of');
require('core-js/modules/es.regexp.to-string');
var shared = require('@vue/shared');
var _objectSpread = _interopDefault(require('@babel/runtime/helpers/objectSpread2'));
require('core-js/modules/es.array.from');
require('core-js/modules/es.string.iterator');
require('core-js/modules/es.symbol');
require('core-js/modules/es.symbol.description');
require('core-js/modules/es.symbol.iterator');
require('core-js/modules/es.array.concat');
require('core-js/modules/es.array.includes');
require('core-js/modules/es.array.iterator');
require('core-js/modules/es.array.map');
require('core-js/modules/es.map');
require('core-js/modules/es.object.is-frozen');
require('core-js/modules/es.reflect.delete-property');
require('core-js/modules/es.reflect.get');
require('core-js/modules/es.reflect.get-prototype-of');
require('core-js/modules/es.reflect.has');
require('core-js/modules/es.reflect.own-keys');
require('core-js/modules/es.reflect.set');
require('core-js/modules/es.set');
require('core-js/modules/es.weak-map');
require('core-js/modules/es.weak-set');
require('core-js/modules/web.dom-collections.iterator');
var _defineEnumerableProperties = _interopDefault(require('@babel/runtime/helpers/defineEnumerableProperties'));
var _defineProperty = _interopDefault(require('@babel/runtime/helpers/defineProperty'));
var _toConsumableArray = _interopDefault(require('@babel/runtime/helpers/toConsumableArray'));
var anObject = _interopDefault(require('core-js/internals/an-object'));
var isObject = _interopDefault(require('core-js/internals/is-object'));
var has$2 = _interopDefault(require('core-js/internals/has'));
var getOwnPropertyDescriptorModule = _interopDefault(require('core-js/internals/object-get-own-property-descriptor'));
var getPrototypeOf = _interopDefault(require('core-js/internals/object-get-prototype-of'));
var createPropertyDescriptor = _interopDefault(require('core-js/internals/create-property-descriptor'));
require('core-js/modules/es.parse-float');
require('core-js/modules/es.array.splice');
require('core-js/modules/es.regexp.exec');
require('core-js/modules/es.string.replace');

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

/*
 * Copyright 2016 Google Inc. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
var proxy = function proxyPolyfill() {
  var lastRevokeFn = null;

  var _ProxyPolyfill;
  /**
   * @param {*} o
   * @return {boolean} whether this is probably a (non-null) Object
   */


  function isObject(o) {
    return o ? _typeof(o) === 'object' || typeof o === 'function' : false;
  }

  function validateProto(proto) {
    if (proto !== null && !isObject(proto)) {
      throw new TypeError('Object prototype may only be an Object or null: ' + proto);
    }
  }

  var $Object = Object; // Closure assumes that `{__proto__: null} instanceof Object` is always true, hence why we check against a different name.

  var noop = function noop() {
    return null;
  };

  var getProto = $Object.getPrototypeOf || ([].__proto__ === Array.prototype ? function getPrototypeOf(O) {
    // If O.[[Prototype]] === null, then the __proto__ accessor won't exist,
    // as it's inherited from `Object.prototype`
    var proto = O.__proto__;
    return isObject(proto) ? proto : null;
  } : noop);
  /**
   * @constructor
   * @param {!Object} target
   * @param {{apply, construct, get, set}} handler
   */

  _ProxyPolyfill = function ProxyPolyfill(target, handler) {
    var newTarget = this && this instanceof _ProxyPolyfill ? this.constructor : undefined;

    if (newTarget === undefined) {
      throw new TypeError("Constructor Proxy requires 'new'");
    }

    if (!isObject(target) || !isObject(handler)) {
      throw new TypeError('Cannot create proxy with a non-object as target or handler');
    } // Construct revoke function, and set lastRevokeFn so that Proxy.revocable can steal it.
    // The caller might get the wrong revoke function if a user replaces or wraps scope.Proxy
    // to call itself, but that seems unlikely especially when using the polyfill.


    var throwRevoked = function throwRevoked() {};

    lastRevokeFn = function lastRevokeFn() {
      /** @suppress {checkTypes} */
      target = null; // clear ref

      throwRevoked = function throwRevoked(trap) {
        throw new TypeError("Cannot perform '".concat(trap, "' on a proxy that has been revoked"));
      };
    };

    setTimeout(function () {
      lastRevokeFn = null;
    }, 0); // Fail on unsupported traps: Chrome doesn't do this, but ensure that users of the polyfill
    // are a bit more careful. Copy the internal parts of handler to prevent user changes.

    var unsafeHandler = handler;
    handler = {
      'get': null,
      'set': null,
      'apply': null,
      'construct': null
    };

    for (var k in unsafeHandler) {

      handler[k] = unsafeHandler[k];
    }

    if (typeof unsafeHandler === 'function') {
      // Allow handler to be a function (which has an 'apply' method). This matches what is
      // probably a bug in native versions. It treats the apply call as a trap to be configured.
      handler.apply = unsafeHandler.apply.bind(unsafeHandler);
    } // Create default getters/setters. Create different code paths as handler.get/handler.set can't
    // change after creation.


    var getter = handler.get ? function (prop) {
      throwRevoked('get');
      return handler.get(this, prop, proxy);
    } : function (prop) {
      throwRevoked('get');
      return this[prop];
    };
    var setter = handler.set ? function (prop, value) {
      throwRevoked('set');
      var status = handler.set(this, prop, value, proxy); // TODO(samthor): If the calling code is in strict mode, throw TypeError.
      // if (!status) {
      // It's (sometimes) possible to work this out, if this code isn't strict- try to load the
      // callee, and if it's available, that code is non-strict. However, this isn't exhaustive.
      // }
    } : function (prop, value) {
      throwRevoked('set');
      this[prop] = value;
    };
    var propertyMap = {}; // Define proxy as an object that extends target.[[Prototype]],
    // or a Function (if either it's callable, or apply is set).

    var proto = getProto(target); // can return null in old browsers

    var proxy;
    var isMethod = false;
    var isArray = false;

    if (typeof target === 'function') {
      proxy = function ProxyPolyfill() {
        var usingNew = this && this.constructor === proxy;
        var args = Array.prototype.slice.call(arguments);
        throwRevoked(usingNew ? 'construct' : 'apply'); // TODO(samthor): Closure compiler doesn't know about 'construct', attempts to rename it.

        if (usingNew && handler['construct']) {
          return handler['construct'].call(this, target, args);
        } else if (!usingNew && handler.apply) {
          return handler['apply'](target, this, args);
        } // since the target was a function, fallback to calling it directly.


        if (usingNew) {
          // inspired by answers to https://stackoverflow.com/q/1606797
          args.unshift(target); // pass class as first arg to constructor, although irrelevant
          // nb. cast to convince Closure compiler that this is a constructor

          var f =
          /** @type {!Function} */
          target.bind.apply(target, args);
          return new f();
        }

        return target.apply(this, args);
      };

      isMethod = true;
    }
    /* else if (target instanceof Array) {
    proxy = [];
    isArray = true;
    } */
    else {
        if (proto) {
          // set delegate proxy proto
          proxy = new proto.constructor();

          var _propertyNames = $Object.getOwnPropertyNames(proto);

          _propertyNames.forEach(function (prop) {
            var real = $Object.getOwnPropertyDescriptor(proto, prop);
            var desc = {
              enumerable: Boolean(real.enumerable),
              get: getter.bind(target, prop) // can not set proto prop
              // set: setter.bind(target, prop)

            };

            try {
              $Object.defineProperty(proxy, prop, desc);
            } catch (e) {}

            propertyMap[prop] = true;
          });
        } else {
          proxy = {};
        }
      }

    var __getter__ = '___@getter___';
    var __setter__ = '___@setter___';
    $Object.defineProperty(proxy, __getter__, {
      enumerable: false,
      get: function get() {
        return getter;
      }
    });
    propertyMap[__getter__] = true;
    $Object.defineProperty(proxy, __setter__, {
      enumerable: false,
      get: function get() {
        return setter;
      }
    });
    propertyMap[__setter__] = true; // Clone direct properties (i.e., not part of a prototype).

    var propertyNames = $Object.getOwnPropertyNames(target);
    propertyNames.forEach(function (prop) {
      if (propertyMap[prop] || (isMethod || isArray) && prop in proxy) {
        return; // ignore properties already here, e.g. 'bind', 'prototype' etc
      }

      var real = $Object.getOwnPropertyDescriptor(target, prop);
      var desc = {
        // in array cases the prop should be deleteable
        configurable: true,
        enumerable: Boolean(real.enumerable),
        get: getter.bind(target, prop),
        set: setter.bind(target, prop)
      };
      $Object.defineProperty(proxy, prop, desc);
      propertyMap[prop] = true;
    }); // Set the prototype, or clone all prototype methods (always required if a getter is provided).
    // TODO(samthor): We don't allow prototype methods to be set. It's (even more) awkward.
    // An alternative here would be to _just_ clone methods to keep behavior consistent.

    var prototypeOk = true;

    if (isMethod || isArray) {
      // Arrays and methods are special: above, we instantiate boring versions of these then swap
      // our their prototype later. So we only need to use setPrototypeOf in these cases. Some old
      // engines support `Object.getPrototypeOf` but not `Object.setPrototypeOf`.
      var setProto = $Object.setPrototypeOf || ([].__proto__ === Array.prototype ? function setPrototypeOf(O, proto) {
        validateProto(proto);
        O.__proto__ = proto;
        return O;
      } : noop);

      if (!(proto && setProto(proxy, proto))) {
        prototypeOk = false;
      }
    }

    if (handler.get || !prototypeOk) {
      for (var _k in target) {
        if (propertyMap[_k]) {
          continue;
        }

        $Object.defineProperty(proxy, _k, {
          get: getter.bind(target, _k)
        });
      }
    } // The Proxy polyfill cannot handle adding new properties. Seal the target and proxy.
    // MYHACK
    // $Object.seal(target);
    // $Object.seal(proxy);


    return proxy; // nb. if isMethod is true, proxy != this
  };

  _ProxyPolyfill.revocable = function (target, handler) {
    var p = new _ProxyPolyfill(target, handler);
    return {
      'proxy': p,
      'revoke': lastRevokeFn
    };
  };

  return _ProxyPolyfill;
};

(function (scope) {
  if (scope['Proxy']) {
    return;
  }

  scope.Proxy = proxy();
  scope.Proxy['revocable'] = scope.Proxy.revocable;
})('undefined' !== typeof process && '[object process]' === {}.toString.call(process) || 'undefined' !== typeof navigator && navigator.product === 'ReactNative' ? commonjsGlobal : self);

function def(obj, key, attrs) {
  Object.defineProperty(obj, key, _objectSpread({
    configurable: true,
    enumerable: false
  }, attrs));
}
function isPolyfillProxy(proxy) {
  var getter = proxy['___@getter___'];
  return !!getter;
}

var nativeGetOwnPropertyNames = Object.getOwnPropertyNames;

function getOwnPropertyNames(o) {
  var _isFunction = shared.isFunction(o);

  var result = nativeGetOwnPropertyNames(o);

  if (_isFunction) {
    var IEKeys = ['caller', 'arguments']; // fix IE Object.getOwnPropertyNames returns caller and arguments in strict mode for function instance
    // https://github.com/zloirock/core-js/issues/825

    result = result.filter(function (k) {
      return IEKeys.indexOf(k) === -1;
    });
  }

  return result;
}

getOwnPropertyNames.toString = function () {
  return 'function getOwnPropertyNames() { [native code] }';
};

def(Object, 'getOwnPropertyNames', {
  value: getOwnPropertyNames,
  writable: true
});

var targetMap = new WeakMap();
var effectStack = [];
var activeEffect;
var ITERATE_KEY = Symbol( 'iterate' );
var MAP_KEY_ITERATE_KEY = Symbol( 'Map key iterate' );

function isEffect(fn) {
  return fn && fn._isEffect === true;
}

function effect(fn) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : shared.EMPTY_OBJ;

  if (isEffect(fn)) {
    fn = fn.raw;
  }

  var effect = createReactiveEffect(fn, options);

  if (!options.lazy) {
    effect();
  }

  return effect;
}

function stop(effect) {
  if (effect.active) {
    cleanup(effect);

    if (effect.options.onStop) {
      effect.options.onStop();
    }

    effect.active = false;
  }
}

var uid = 0;

function createReactiveEffect(fn, options) {
  var effect = function reactiveEffect() {
    if (!effect.active) {
      return options.scheduler ? undefined : fn();
    }

    if (!effectStack.includes(effect)) {
      cleanup(effect);

      try {
        enableTracking();
        effectStack.push(effect);
        activeEffect = effect;
        return fn();
      } finally {
        effectStack.pop();
        resetTracking();
        activeEffect = effectStack[effectStack.length - 1];
      }
    }
  };

  effect.id = uid++;
  effect._isEffect = true;
  effect.active = true;
  effect.raw = fn;
  effect.deps = [];
  effect.options = options;
  return effect;
}

function cleanup(effect) {
  var deps = effect.deps;

  if (deps.length) {
    for (var i = 0; i < deps.length; i++) {
      deps[i].delete(effect);
    }

    deps.length = 0;
  }
}

var shouldTrack = true;
var trackStack = [];

function pauseTracking() {
  trackStack.push(shouldTrack);
  shouldTrack = false;
}

function enableTracking() {
  trackStack.push(shouldTrack);
  shouldTrack = true;
}

function resetTracking() {
  var last = trackStack.pop();
  shouldTrack = last === undefined ? true : last;
}

function track(target, type, key) {
  if (!shouldTrack || activeEffect === undefined) {
    return;
  }

  var depsMap = targetMap.get(target);

  if (!depsMap) {
    targetMap.set(target, depsMap = new Map());
  }

  var dep = depsMap.get(key);

  if (!dep) {
    depsMap.set(key, dep = new Set());
  }

  if (!dep.has(activeEffect)) {
    dep.add(activeEffect);
    activeEffect.deps.push(dep);

    if ( activeEffect.options.onTrack) {
      activeEffect.options.onTrack({
        effect: activeEffect,
        target: target,
        type: type,
        key: key
      });
    }
  }
}

function trigger(target, type, key, newValue, oldValue, oldTarget) {
  var depsMap = targetMap.get(target);

  if (!depsMap) {
    // never been tracked
    return;
  }

  var effects = new Set();

  var add = function add(effectsToAdd) {
    if (effectsToAdd) {
      effectsToAdd.forEach(function (effect) {
        return effects.add(effect);
      });
    }
  };

  if (type === "clear"
  /* CLEAR */
  ) {
      // collection being cleared
      // trigger all effects for target
      depsMap.forEach(add);
    } else if (key === 'length' && shared.isArray(target)) {
    depsMap.forEach(function (dep, key) {
      if (key === 'length' || key >= newValue) {
        add(dep);
      }
    });
  } else {
    // schedule runs for SET | ADD | DELETE
    if (key !== void 0) {
      add(depsMap.get(key));
    } // also run for iteration key on ADD | DELETE | Map.SET


    var isAddOrDelete = type === "add"
    /* ADD */
    || type === "delete"
    /* DELETE */
    && !shared.isArray(target);

    if (isAddOrDelete || type === "set"
    /* SET */
    && target instanceof Map) {
      add(depsMap.get(shared.isArray(target) ? 'length' : ITERATE_KEY));
    }

    if (isAddOrDelete && target instanceof Map) {
      add(depsMap.get(MAP_KEY_ITERATE_KEY));
    }
  }

  var run = function run(effect) {
    if ( effect.options.onTrigger) {
      effect.options.onTrigger({
        effect: effect,
        target: target,
        key: key,
        type: type,
        newValue: newValue,
        oldValue: oldValue,
        oldTarget: oldTarget
      });
    }

    if (effect.options.scheduler) {
      effect.options.scheduler(effect);
    } else {
      effect();
    }
  };

  effects.forEach(run);
}

var builtInSymbols = new Set(Object.getOwnPropertyNames(Symbol).map(function (key) {
  return Symbol[key];
}).filter(shared.isSymbol));
var get = /*#__PURE__*/createGetter();
var shallowGet = /*#__PURE__*/createGetter(false, true);
var readonlyGet = /*#__PURE__*/createGetter(true);
var shallowReadonlyGet = /*#__PURE__*/createGetter(true, true);
var arrayInstrumentations = {};
['includes', 'indexOf', 'lastIndexOf'].forEach(function (key) {
  arrayInstrumentations[key] = function () {
    var arr = toRaw(this);

    for (var i = 0, l = this.length; i < l; i++) {
      track(arr, "get"
      /* GET */
      , i + '');
    } // we run the method using the original args first (which may be reactive)


    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var res = arr[key].apply(arr, args);

    if (res === -1 || res === false) {
      // if that didn't work, run it again using raw values.
      return arr[key].apply(arr, _toConsumableArray(args.map(toRaw)));
    } else {
      return res;
    }
  };
});

function createGetter() {
  var isReadonly = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  var shallow = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  return function get(target, key, receiver) {
    if (key === "__v_isReactive"
    /* IS_REACTIVE */
    ) {
        return !isReadonly;
      } else if (key === "__v_isReadonly"
    /* IS_READONLY */
    ) {
        return isReadonly;
      } else if (key === "__v_raw"
    /* RAW */
    && receiver === (isReadonly ? target["__v_readonly"
    /* READONLY */
    ] : target["__v_reactive"
    /* REACTIVE */
    ])) {
      return target;
    }

    var targetIsArray = shared.isArray(target);

    if (targetIsArray && shared.hasOwn(arrayInstrumentations, key)) {
      return Reflect.get(arrayInstrumentations, key, receiver);
    }

    var res = Reflect.get(target, key, receiver);

    if (shared.isSymbol(key) ? builtInSymbols.has(key) : key === "__proto__" || key === "__v_isRef") {
      return res;
    }

    if (!isReadonly) {
      track(target, "get"
      /* GET */
      , key);
    }

    if (shallow) {
      return res;
    }

    if (isRef(res)) {
      // ref unwrapping, only for Objects, not for Arrays.
      return targetIsArray ? res : res.value;
    }

    if (shared.isObject(res)) {
      // Convert returned value into a proxy as well. we do the isObject check
      // here to avoid invalid value warning. Also need to lazy access readonly
      // and reactive here to avoid circular dependency.
      return isReadonly ? readonly(res) : reactive(res);
    }

    return res;
  };
}

var set = /*#__PURE__*/createSetter();
var shallowSet = /*#__PURE__*/createSetter(true);

function createSetter() {
  var shallow = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  return function set(target, key, value, receiver) {
    var oldValue = target[key];

    if (!shallow) {
      value = toRaw(value);

      if (!shared.isArray(target) && isRef(oldValue) && !isRef(value)) {
        oldValue.value = value;
        return true;
      }
    }

    var hadKey = shared.hasOwn(target, key);
    var result = Reflect.set(target, key, value, receiver); // don't trigger if target is something up in the prototype chain of original

    if (target === toRaw(receiver)) {
      if (!hadKey) {
        trigger(target, "add"
        /* ADD */
        , key, value);
      } else if (shared.hasChanged(value, oldValue)) {
        trigger(target, "set"
        /* SET */
        , key, value, oldValue);
      }
    }

    return result;
  };
}

function deleteProperty(target, key) {
  var hadKey = shared.hasOwn(target, key);
  var oldValue = target[key];
  var result = Reflect.deleteProperty(target, key);

  if (result && hadKey) {
    trigger(target, "delete"
    /* DELETE */
    , key, undefined, oldValue);
  }

  return result;
}

function has(target, key) {
  var result = Reflect.has(target, key);

  if (!shared.isSymbol(key) || !builtInSymbols.has(key)) {
    track(target, "has"
    /* HAS */
    , key);
  }

  return result;
}

function ownKeys(target) {
  track(target, "iterate"
  /* ITERATE */
  , ITERATE_KEY);
  return Reflect.ownKeys(target);
}

var mutableHandlers = {
  get: get,
  set: set,
  deleteProperty: deleteProperty,
  has: has,
  ownKeys: ownKeys
};
var readonlyHandlers = {
  get: readonlyGet,
  has: has,
  ownKeys: ownKeys,
  set: function set(target, key) {
    {
      console.warn("Set operation on key \"".concat(String(key), "\" failed: target is readonly."), target);
    }

    return true;
  },
  deleteProperty: function deleteProperty(target, key) {
    {
      console.warn("Delete operation on key \"".concat(String(key), "\" failed: target is readonly."), target);
    }

    return true;
  }
};
var shallowReactiveHandlers = shared.extend({}, mutableHandlers, {
  get: shallowGet,
  set: shallowSet
}); // Props handlers are special in the sense that it should not unwrap top-level
// refs (in order to allow refs to be explicitly passed down), but should
// retain the reactivity of the normal readonly object.

var shallowReadonlyHandlers = shared.extend({}, readonlyHandlers, {
  get: shallowReadonlyGet
});

var toReactive = function toReactive(value) {
  return shared.isObject(value) ? reactive(value) : value;
};

var toReadonly = function toReadonly(value) {
  return shared.isObject(value) ? readonly(value) : value;
};

var toShallow = function toShallow(value) {
  return value;
};

var getProto = function getProto(v) {
  return Reflect.getPrototypeOf(v);
};

function get$1(target, key, wrap) {
  target = toRaw(target);
  var rawKey = toRaw(key);

  if (key !== rawKey) {
    track(target, "get"
    /* GET */
    , key);
  }

  track(target, "get"
  /* GET */
  , rawKey);

  var _getProto = getProto(target),
      has = _getProto.has,
      get = _getProto.get;

  if (has.call(target, key)) {
    return wrap(get.call(target, key));
  } else if (has.call(target, rawKey)) {
    return wrap(get.call(target, rawKey));
  }
}

function has$1(key) {
  var target = toRaw(this);
  var rawKey = toRaw(key);

  if (key !== rawKey) {
    track(target, "has"
    /* HAS */
    , key);
  }

  track(target, "has"
  /* HAS */
  , rawKey);
  var has = getProto(target).has;
  return has.call(target, key) || has.call(target, rawKey);
}

function size(target) {
  target = toRaw(target);
  track(target, "iterate"
  /* ITERATE */
  , ITERATE_KEY);
  return Reflect.get(getProto(target), 'size', target);
}

function add(value) {
  value = toRaw(value);
  var target = toRaw(this);
  var proto = getProto(target);
  var hadKey = proto.has.call(target, value);
  var result = proto.add.call(target, value);

  if (!hadKey) {
    trigger(target, "add"
    /* ADD */
    , value, value);
  }

  return result;
}

function set$1(key, value) {
  value = toRaw(value);
  var target = toRaw(this);

  var _getProto2 = getProto(target),
      has = _getProto2.has,
      get = _getProto2.get,
      set = _getProto2.set;

  var hadKey = has.call(target, key);

  if (!hadKey) {
    key = toRaw(key);
    hadKey = has.call(target, key);
  } else {
    checkIdentityKeys(target, has, key);
  }

  var oldValue = get.call(target, key);
  var result = set.call(target, key, value);

  if (!hadKey) {
    trigger(target, "add"
    /* ADD */
    , key, value);
  } else if (shared.hasChanged(value, oldValue)) {
    trigger(target, "set"
    /* SET */
    , key, value, oldValue);
  }

  return result;
}

function deleteEntry(key) {
  var target = toRaw(this);

  var _getProto3 = getProto(target),
      has = _getProto3.has,
      get = _getProto3.get,
      del = _getProto3.delete;

  var hadKey = has.call(target, key);

  if (!hadKey) {
    key = toRaw(key);
    hadKey = has.call(target, key);
  } else {
    checkIdentityKeys(target, has, key);
  }

  var oldValue = get ? get.call(target, key) : undefined; // forward the operation before queueing reactions

  var result = del.call(target, key);

  if (hadKey) {
    trigger(target, "delete"
    /* DELETE */
    , key, undefined, oldValue);
  }

  return result;
}

function clear() {
  var target = toRaw(this);
  var hadItems = target.size !== 0;
  var oldTarget =  target instanceof Map ? new Map(target) : new Set(target) ; // forward the operation before queueing reactions

  var result = getProto(target).clear.call(target);

  if (hadItems) {
    trigger(target, "clear"
    /* CLEAR */
    , undefined, undefined, oldTarget);
  }

  return result;
}

function createForEach(isReadonly, shallow) {
  return function forEach(callback, thisArg) {
    var observed = this;
    var target = toRaw(observed);
    var wrap = isReadonly ? toReadonly : shallow ? toShallow : toReactive;
    !isReadonly && track(target, "iterate"
    /* ITERATE */
    , ITERATE_KEY); // important: create sure the callback is
    // 1. invoked with the reactive map as `this` and 3rd arg
    // 2. the value received should be a corresponding reactive/readonly.

    function wrappedCallback(value, key) {
      return callback.call(thisArg, wrap(value), wrap(key), observed);
    }

    return getProto(target).forEach.call(target, wrappedCallback);
  };
}

function createIterableMethod(method, isReadonly, shallow) {
  return function () {
    var target = toRaw(this);
    var isMap = target instanceof Map;
    var isPair = method === 'entries' || method === Symbol.iterator && isMap;
    var isKeyOnly = method === 'keys' && isMap;

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    var innerIterator = getProto(target)[method].apply(target, args);
    var wrap = isReadonly ? toReadonly : shallow ? toShallow : toReactive;
    !isReadonly && track(target, "iterate"
    /* ITERATE */
    , isKeyOnly ? MAP_KEY_ITERATE_KEY : ITERATE_KEY); // return a wrapped iterator which returns observed versions of the
    // values emitted from the real iterator

    return _defineProperty({
      // iterator protocol
      next: function next() {
        var _innerIterator$next = innerIterator.next(),
            value = _innerIterator$next.value,
            done = _innerIterator$next.done;

        return done ? {
          value: value,
          done: done
        } : {
          value: isPair ? [wrap(value[0]), wrap(value[1])] : wrap(value),
          done: done
        };
      }
    }, Symbol.iterator, function () {
      return this;
    });
  };
}

function createReadonlyMethod(type) {
  return function () {
    {
      var key = (arguments.length <= 0 ? undefined : arguments[0]) ? "on key \"".concat(arguments.length <= 0 ? undefined : arguments[0], "\" ") : "";
      console.warn("".concat(shared.capitalize(type), " operation ").concat(key, "failed: target is readonly."), toRaw(this));
    }

    return type === "delete"
    /* DELETE */
    ? false : this;
  };
}

var mutableInstrumentations = {
  get: function get(key) {
    return get$1(this, key, toReactive);
  },

  get size() {
    return size(this);
  },

  has: has$1,
  add: add,
  set: set$1,
  delete: deleteEntry,
  clear: clear,
  forEach: createForEach(false, false)
};
var shallowInstrumentations = {
  get: function get(key) {
    return get$1(this, key, toShallow);
  },

  get size() {
    return size(this);
  },

  has: has$1,
  add: add,
  set: set$1,
  delete: deleteEntry,
  clear: clear,
  forEach: createForEach(false, true)
};
var readonlyInstrumentations = {
  get: function get(key) {
    return get$1(this, key, toReadonly);
  },

  get size() {
    return size(this);
  },

  has: has$1,
  add: createReadonlyMethod("add"
  /* ADD */
  ),
  set: createReadonlyMethod("set"
  /* SET */
  ),
  delete: createReadonlyMethod("delete"
  /* DELETE */
  ),
  clear: createReadonlyMethod("clear"
  /* CLEAR */
  ),
  forEach: createForEach(true, false)
};
var iteratorMethods = ['keys', 'values', 'entries', Symbol.iterator];
iteratorMethods.forEach(function (method) {
  mutableInstrumentations[method] = createIterableMethod(method, false, false);
  readonlyInstrumentations[method] = createIterableMethod(method, true, false);
  shallowInstrumentations[method] = createIterableMethod(method, false, true);
});

function createInstrumentationGetter(isReadonly, shallow) {
  var instrumentations = shallow ? shallowInstrumentations : isReadonly ? readonlyInstrumentations : mutableInstrumentations;
  return function (target, key, receiver) {
    if (key === "__v_isReactive"
    /* IS_REACTIVE */
    ) {
        return !isReadonly;
      } else if (key === "__v_isReadonly"
    /* IS_READONLY */
    ) {
        return isReadonly;
      } else if (key === "__v_raw"
    /* RAW */
    ) {
        return target;
      }

    return Reflect.get(shared.hasOwn(instrumentations, key) && key in target ? instrumentations : target, key, receiver);
  };
}

var mutableCollectionHandlers = {
  get: createInstrumentationGetter(false, false)
};
var shallowCollectionHandlers = {
  get: createInstrumentationGetter(false, true)
};
var readonlyCollectionHandlers = {
  get: createInstrumentationGetter(true, false)
};

function checkIdentityKeys(target, has, key) {
  var rawKey = toRaw(key);

  if (rawKey !== key && has.call(target, rawKey)) {
    var type = shared.toRawType(target);
    console.warn("Reactive ".concat(type, " contains both the raw and reactive ") + "versions of the same object".concat(type === "Map" ? "as keys" : "", ", ") + "which can lead to inconsistencies. " + "Avoid differentiating between the raw and reactive versions " + "of an object and only use the reactive version if possible.");
  }
}

var collectionTypes = new Set([Set, Map, WeakMap, WeakSet]);
var isObservableType = /*#__PURE__*/shared.makeMap('Object,Array,Map,Set,WeakMap,WeakSet');

var canObserve = function canObserve(value) {
  return !value["__v_skip"
  /* SKIP */
  ] && isObservableType(shared.toRawType(value)) && !Object.isFrozen(value);
};

function reactive(target) {
  // if trying to observe a readonly proxy, return the readonly version.
  if (target && target["__v_isReadonly"
  /* IS_READONLY */
  ]) {
    return target;
  }

  return createReactiveObject(target, false, mutableHandlers, mutableCollectionHandlers);
} // Return a reactive-copy of the original object, where only the root level
// properties are reactive, and does NOT unwrap refs nor recursively convert
// returned properties.


function shallowReactive(target) {
  return createReactiveObject(target, false, shallowReactiveHandlers, shallowCollectionHandlers);
}

function readonly(target) {
  return createReactiveObject(target, true, readonlyHandlers, readonlyCollectionHandlers);
} // Return a reactive-copy of the original object, where only the root level
// properties are readonly, and does NOT unwrap refs nor recursively convert
// returned properties.
// This is used for creating the props proxy object for stateful components.


function shallowReadonly(target) {
  return createReactiveObject(target, true, shallowReadonlyHandlers, readonlyCollectionHandlers);
}

function createReactiveObject(target, isReadonly, baseHandlers, collectionHandlers) {
  if (!shared.isObject(target)) {
    {
      console.warn("value cannot be made reactive: ".concat(String(target)));
    }

    return target;
  } // target is already a Proxy, return it.
  // exception: calling readonly() on a reactive object


  if (target["__v_raw"
  /* RAW */
  ] && !(isReadonly && target["__v_isReactive"
  /* IS_REACTIVE */
  ])) {
    return target;
  } // target already has corresponding Proxy


  var reactiveFlag = isReadonly ? "__v_readonly"
  /* READONLY */
  : "__v_reactive"
  /* REACTIVE */
  ;

  if (shared.hasOwn(target, reactiveFlag)) {
    return target[reactiveFlag];
  } // only a whitelist of value types can be observed.


  if (!canObserve(target)) {
    return target;
  }

  var observed = new Proxy(target, collectionTypes.has(target.constructor) ? collectionHandlers : baseHandlers);
  shared.def(target, reactiveFlag, observed);
  return observed;
}

function isReactive(value) {
  if (isReadonly(value)) {
    return isReactive(value["__v_raw"
    /* RAW */
    ]);
  }

  return !!(value && value["__v_isReactive"
  /* IS_REACTIVE */
  ]);
}

function isReadonly(value) {
  return !!(value && value["__v_isReadonly"
  /* IS_READONLY */
  ]);
}

function isProxy(value) {
  return isReactive(value) || isReadonly(value);
}

function toRaw(observed) {
  return observed && toRaw(observed["__v_raw"
  /* RAW */
  ]) || observed;
}

function markRaw(value) {
  shared.def(value, "__v_skip"
  /* SKIP */
  , true);
  return value;
}

var convert = function convert(val) {
  return shared.isObject(val) ? reactive(val) : val;
};

function isRef(r) {
  return r ? r.__v_isRef === true : false;
}

function ref(value) {
  return createRef(value);
}

function shallowRef(value) {
  return createRef(value, true);
}

function createRef(rawValue) {
  var shallow = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  if (isRef(rawValue)) {
    return rawValue;
  }

  var value = shallow ? rawValue : convert(rawValue);
  var r = {
    __v_isRef: true,

    get value() {
      track(r, "get"
      /* GET */
      , 'value');
      return value;
    },

    set value(newVal) {
      if (shared.hasChanged(toRaw(newVal), rawValue)) {
        rawValue = newVal;
        value = shallow ? newVal : convert(newVal);
        trigger(r, "set"
        /* SET */
        , 'value', newVal);
      }
    }

  };
  return r;
}

function triggerRef(ref) {
  trigger(ref, "set"
  /* SET */
  , 'value',  ref.value );
}

function unref(ref) {
  return isRef(ref) ? ref.value : ref;
}

var shallowUnwrapHandlers = {
  get: function get(target, key, receiver) {
    return unref(Reflect.get(target, key, receiver));
  },
  set: function set(target, key, value, receiver) {
    var oldValue = target[key];

    if (isRef(oldValue) && !isRef(value)) {
      oldValue.value = value;
      return true;
    } else {
      return Reflect.set(target, key, value, receiver);
    }
  }
};

function proxyRefs(objectWithRefs) {
  return isReactive(objectWithRefs) ? objectWithRefs : new Proxy(objectWithRefs, shallowUnwrapHandlers);
}

function customRef(factory) {
  var _factory = factory(function () {
    return track(r, "get"
    /* GET */
    , 'value');
  }, function () {
    return trigger(r, "set"
    /* SET */
    , 'value');
  }),
      get = _factory.get,
      set = _factory.set;

  var r = {
    __v_isRef: true,

    get value() {
      return get();
    },

    set value(v) {
      set(v);
    }

  };
  return r;
}

function toRefs(object) {
  if ( !isProxy(object)) {
    console.warn("toRefs() expects a reactive object but received a plain one.");
  }

  var ret = {};

  for (var key in object) {
    ret[key] = toRef(object, key);
  }

  return ret;
}

function toRef(object, key) {
  return {
    __v_isRef: true,

    get value() {
      return object[key];
    },

    set value(newVal) {
      object[key] = newVal;
    }

  };
}

function computed(getterOrOptions) {
  var _value, _value2, _computed, _mutatorMap;

  var getter;
  var setter;

  if (shared.isFunction(getterOrOptions)) {
    getter = getterOrOptions;
    setter =  function () {
      console.warn('Write operation failed: computed value is readonly');
    } ;
  } else {
    getter = getterOrOptions.get;
    setter = getterOrOptions.set;
  }

  var dirty = true;
  var value;
  var computed;
  var runner = effect(getter, {
    lazy: true,
    scheduler: function scheduler() {
      if (!dirty) {
        dirty = true;
        trigger(computed, "set"
        /* SET */
        , 'value');
      }
    }
  });
  computed = (_computed = {
    __v_isRef: true
  }, _defineProperty(_computed, "__v_isReadonly"
  /* IS_READONLY */
  , shared.isFunction(getterOrOptions) || !getterOrOptions.set), _defineProperty(_computed, "effect", runner), _value = "value", _mutatorMap = {}, _mutatorMap[_value] = _mutatorMap[_value] || {}, _mutatorMap[_value].get = function () {
    if (dirty) {
      value = runner();
      dirty = false;
    }

    track(computed, "get"
    /* GET */
    , 'value');
    return value;
  }, _value2 = "value", _mutatorMap[_value2] = _mutatorMap[_value2] || {}, _mutatorMap[_value2].set = function (newValue) {
    setter(newValue);
  }, _defineEnumerableProperties(_computed, _mutatorMap), _computed);
  return computed;
}

var originFrom = Array.from;
originFrom && (Array.from = function (arrayLike) {
  var ret = originFrom(arrayLike);

  if (!isPolyfillProxy(arrayLike)) {
    return ret;
  }

  var raw = toRaw(arrayLike); // at least call once for ITERATE_KEY

  track(raw, 'interate', ITERATE_KEY); // check forEach
  // @ts-ignore

  if (raw.forEach) {
    // @ts-ignore
    raw.forEach(function (_, key) {
      track(raw, 'get', key);
    });
  } else {
    var len = raw.length;

    for (var i = 0; i < len; i++) {
      track(raw, 'get', i);
    }
  }

  return ret;
});

var NativeProxy = self.Proxy;
var isNativeProxy = NativeProxy && /native code/.test(NativeProxy.toString());

if (!isNativeProxy) {
  // hack reflect
  // because patch-pkg cannot patch peer deps core-js
  var _Reflect = self.Reflect;

  _Reflect.set = function (target, propertyKey, V)
  /* , receiver */
  {
    var receiver = arguments.length < 4 ? target : arguments[3];
    var ownDescriptor = getOwnPropertyDescriptorModule.f(anObject(target), propertyKey); // let existingDescriptor

    var prototype;

    if (!ownDescriptor) {
      if (isObject(prototype = getPrototypeOf(target))) {
        return _Reflect.set(prototype, propertyKey, V, receiver);
      }

      ownDescriptor = createPropertyDescriptor(0);
    }

    if (has$2(ownDescriptor, 'value')) {
      if (ownDescriptor.writable === false || !isObject(receiver)) return false; // just set value

      target[propertyKey] = V; // if (existingDescriptor = getOwnPropertyDescriptorModule.f(receiver, propertyKey)) {
      //   if (existingDescriptor.get || existingDescriptor.set || existingDescriptor.writable === false) return false;
      //   existingDescriptor.value = V;
      //   definePropertyModule.f(receiver, propertyKey, existingDescriptor);
      // } else definePropertyModule.f(receiver, propertyKey, createPropertyDescriptor(0, V));

      return true;
    }

    return ownDescriptor.set === undefined ? false : (ownDescriptor.set.call(receiver, V), true);
  };
}

var ReactiveFlags = {
  SKIP: '__v_skip',
  IS_REACTIVE: '__v_isReactive',
  IS_READONLY: '__v_isReadonly',
  RAW: '__v_raw',
  REACTIVE: '__v_reactive',
  READONLY: '__v_readonly'
};
function isValidArrayIndex(val) {
  var n = parseFloat(String(val));
  return n >= 0 && Math.floor(n) === n && isFinite(val);
}
function handleReadonly(proxy, key) {
  var _isReadonly = isReadonly(proxy);

  if (_isReadonly) {
    console.warn("Set operation on key \"".concat(String(key), "\" failed: target is readonly."), proxy);
  }

  return _isReadonly;
}
function addProp(proxy, key, val) {
  var _isReactive = isReactive(proxy);

  if (_isReactive) {
    var target = toRaw(proxy);
    target[key] = toRaw(val);
    var setter = proxy['___@setter___'];
    var getter = proxy['___@getter___'];
    var real = Object.getOwnPropertyDescriptor(target, key);
    var desc = {
      configurable: true,
      enumerable: Boolean(real && real.enumerable),
      get: getter.bind(target, key),
      set: setter.bind(target, key)
    };
    def(proxy, String(key), desc);
    trigger(target, 'add', key, val);
  } else if (handleReadonly(proxy, key)) ; else {
    // just set
    proxy[key] = val;
  }
}
var toReactive$1 = function toReactive(value) {
  return shared.isObject(value) ? reactive(value) : value;
};
var toReadonly$1 = function toReadonly(value) {
  return shared.isObject(value) ? readonly(value) : value;
};
var toShallow$1 = function toShallow(value) {
  return value;
};
function memoize(func) {
  var memoized = function memoized(key) {
    var cache = memoized.cache;

    if (cache.has(key)) {
      return cache.get(key);
    }

    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var result = func.apply(this, [key].concat(args));
    memoized.cache = cache.set(key, result);
    return result;
  };

  memoized.cache = new Map();
  return memoized;
}
function protoAugment(target, src) {
  target.__proto__ = src;
}
function copyAugment(target, src, keys) {
  keys.forEach(function (key) {
    def(target, key, {
      writable: true,
      value: src[key]
    });
  });
}

var arrayProto = Array.prototype; // const methods = Object.getOwnPropertyNames(arrayProto)

var arrayMethods = Object.create(arrayProto);
var methodsToPatch = ['push', 'pop', 'shift', 'unshift', 'splice', 'sort', 'reverse']; // hook API
// methods.forEach(method => {
//   if (methodsToPatch.includes(method)) {
//     return
//   }
//   const original = arrayProto[method]
//   def(arrayMethods, method, {
//     writable: true,
//     value: function mutator (...args: any[]) {
//       // const target = toRaw(this) as any
//       debugger
//       const result = original.apply(this, args)
//       return result
//     }
//   })
// })

methodsToPatch.forEach(function (method) {
  // cache original method
  var original = arrayProto[method];
  def(arrayMethods, method, {
    writable: true,
    value: function mutator() {
      var target = toRaw(this);
      var proxy = isProxy(this) ? this : target[ReactiveFlags.REACTIVE] || target[ReactiveFlags.READONLY];

      if (handleReadonly(proxy, method)) {
        return;
      }

      var oldThis = target.slice();
      var oldLen = oldThis.length;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var result = original.apply(target, args);
      var newLen = target.length;
      var i = 0;
      var j = 0;

      while (i < newLen || j < oldLen) {
        if (i < newLen) {
          // update
          var oldVal = oldThis[i];
          var newVal = target[i];

          if (!(i in oldThis)) {
            // set
            addProp(proxy, i, newVal);
          } else {
            if (oldVal !== newVal) {
              trigger(target, 'set', i, newVal, oldVal);
            }
          }
        } else {
          delete proxy[i];
          proxy.length -= 1; // delete old

          trigger(target, 'delete', i, undefined, oldThis[i]);
        }

        i++;
        j++;
      } // if (oldLen !== newLen) {
      //   // length changed
      //   trigger(target, 'set' as TriggerOpTypes, 'length', target.length, oldLen)
      // }
      // always trigger clear to hack trigger all effects


      trigger(target, 'clear', 'length', target.length, oldLen);
      return result;
    }
  });
});
var method = 'forEach';
var _forEach = arrayProto[method];
def(arrayMethods, method, {
  writable: true,
  value: function mutator(callback, thisArg) {
    var target = toRaw(this);

    var _isReadonly = isReadonly(this);

    var _isReactive = isReactive(this);

    var proxy = _isReadonly || _isReactive ? this : target[ReactiveFlags.REACTIVE] || target[ReactiveFlags.READONLY];
    !_isReadonly && track(target, 'iterate', ITERATE_KEY);
    var wrap = _isReadonly ? toReadonly$1 : _isReactive ? toReactive$1 : toShallow$1;

    function wrappedCallback(value, key) {
      return callback.call(thisArg, wrap(value), key, proxy);
    }

    return _forEach.call(target, wrappedCallback);
  }
});

if (!isNativeProxy) {
  var hasProto = ('__proto__' in {});
  var arrayKeys = Object.getOwnPropertyNames(arrayMethods); // hack Proxy for Vue

  var ProxyPolyfill = function ProxyPolyfill(target, handler) {
    var proxy = new NativeProxy(target, handler);

    if (Array.isArray(target)) {
      // array cases
      if (hasProto) {
        protoAugment(target, arrayMethods);
      } else {
        copyAugment(target, arrayMethods, arrayKeys);
      }
    }

    var _loop = function _loop(k) {
      var key = ReactiveFlags[k]; // undefined do not use to define and should not define
      // if target hasOwn key can not define again

      if (!shared.hasOwn(target, key)) {
        var initVal = handler.get(target, key, proxy);

        if (key !== ReactiveFlags.READONLY || initVal !== undefined) {
          def(proxy, key, {
            get: function get() {
              return handler.get(target, key, proxy);
            }
          });
        }
      }
    };

    for (var k in ReactiveFlags) {
      _loop(k);
    }

    return proxy;
  };

  ProxyPolyfill.revocable = NativeProxy.revocable;
  self.Proxy = ProxyPolyfill;
}

/**
 * Set a property on an object. Adds the new property and
 * triggers change notification if the property doesn't
 * already exist.
 */

function set$2(target, key, val) {
  var proxy = target;

  if (!isPolyfillProxy(proxy)) {
    proxy[key] = val;
    return val;
  }

  var _isReactive = isReactive(proxy);

  var _isReadonly = isReadonly(proxy);

  target = toRaw(proxy);

  if (!_isReactive && !_isReadonly) {
    proxy[key] = val;
    return val;
  }

  if (Array.isArray(target) && isValidArrayIndex(key)) {
    target.splice(key, 1, val);
    return val;
  } // already exits


  if (key in proxy && !(key in Object.prototype)) {
    proxy[key] = val;
    return val;
  }

  addProp(proxy, key, val);
  return val;
}

/**
 * Get a property on an object.
 * Auto track deps.
 */
function get$2(object, path, defaultVal) {
  if (object === null || object === undefined) {
    return defaultVal;
  }

  var proxy = object;
  var target = toRaw(proxy);
  var paths = isKey(path, target) ? [path] : castPath(path);
  var index = 0;
  var length = paths.length;

  while (target && index < length) {
    var k = toKey(paths[index++]);
    track(target, 'get', k);
    target = toRaw(target[k]);
  }

  var result = index && index === length ? target : undefined;
  return result === undefined ? defaultVal : result;
}
function getLength(array) {
  var len = array.length;
  track(toRaw(array), 'get', 'length');
  return len;
}
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/;
var reIsPlainProp = /^\w*$/;
var reLeadingDot = /^\./;
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
var reEscapeChar = /\\(\\)?/g;

function isKey(value, object) {
  if (shared.isArray(value)) {
    return false;
  }

  var type = _typeof(value);

  if (type == 'number' || type == 'boolean' || value === null || value === undefined) {
    return true;
  }

  var strValue = String(value);
  return reIsPlainProp.test(strValue) || !reIsDeepProp.test(strValue) || object && strValue in Object(object);
}

var stringToPath = memoize(function (str) {
  var _str = String(str);

  var result = [];

  if (reLeadingDot.test(_str)) {
    result.push('');
  }

  _str.replace(rePropName, function (match, number, quote, str) {
    result.push(quote ? str.replace(reEscapeChar, '$1') : number || match);
    return str;
  });

  return result;
});

function castPath(value) {
  return shared.isArray(value) ? value : stringToPath(value);
}

var INFINITY = 1 / 0;

function toKey(value) {
  if (shared.isString(value)) {
    return value;
  }

  var result = String(value);
  return result == '0' && 1 / value == -INFINITY ? '-0' : result;
}

/**
 * Delete a property and trigger change if necessary.
 */

function del(target, key) {
  var proxy = target;

  if (!isPolyfillProxy(proxy)) {
    delete proxy[key];
  }

  target = toRaw(proxy);

  if (handleReadonly(target, key)) {
    return;
  }

  var _isReactive = isReactive(proxy);

  if (!_isReactive) {
    delete proxy[key];
    return;
  }

  if (Array.isArray(target) && isValidArrayIndex(key)) {
    target.splice(key, 1);
    return;
  }

  if (!shared.hasOwn(target, key)) {
    return;
  }

  var oldVal = target[key];
  delete target[key];
  delete proxy[key];
  trigger(target, 'delete', key, undefined, oldVal);
}

exports.ITERATE_KEY = ITERATE_KEY;
exports.computed = computed;
exports.customRef = customRef;
exports.del = del;
exports.effect = effect;
exports.enableTracking = enableTracking;
exports.get = get$2;
exports.getLength = getLength;
exports.isProxy = isProxy;
exports.isReactive = isReactive;
exports.isReadonly = isReadonly;
exports.isRef = isRef;
exports.markRaw = markRaw;
exports.pauseTracking = pauseTracking;
exports.proxyRefs = proxyRefs;
exports.reactive = reactive;
exports.readonly = readonly;
exports.ref = ref;
exports.resetTracking = resetTracking;
exports.set = set$2;
exports.shallowReactive = shallowReactive;
exports.shallowReadonly = shallowReadonly;
exports.shallowRef = shallowRef;
exports.stop = stop;
exports.toRaw = toRaw;
exports.toRef = toRef;
exports.toRefs = toRefs;
exports.track = track;
exports.trigger = trigger;
exports.triggerRef = triggerRef;
exports.unref = unref;
